#ifndef SETS_H
#define SETS_H

struct BinTreeNode;
typedef BinTreeNode *PBinTreeNode;

class Set 
{
public:
  Set ();
  virtual ~Set ();
  virtual const Set& operator= (const Set&);
  virtual Set& add(int);
  virtual bool member (int) const;   
  virtual Set& clear();
  int extent () const;
  virtual Set* Generacopia () const;
protected:
  int size;  
  virtual void copyMembers (Set& into) const;
};

/////////////////////////////
class ArraySet : public Set
{
public:
  ArraySet ();
  ~ArraySet ();             //prototipo del destructor de la clase Arrayset
  Set& add(int);
  bool member (int) const;   
  Set& clear();
  Set* Generacopia() const; //prototipo de la funcin que genera copia (duplicado)del arreglo
private:
  int members[100];
  void copyMembers (ArraySet& into) const;
};

/////////////////////////////
class TreeSet:  public Set
{
public:
  TreeSet ();

  ////////////////////////////////////////////////////

  /********************* lo mio *********************/

  ////////////////////////////////////////////////////

  ~TreeSet ();
  TreeSet (const TreeSet& s);
  TreeSet& operator= (const TreeSet &s);
  Set* Generacopia () const;

  ////////////////////////////////////////////////////

  /********************* lo mio *********************/

  ////////////////////////////////////////////////////

  Set& add(int);
  bool member (int) const;   
  Set& clear();

private:
  PBinTreeNode root;

////////////////////////////////////////////////////

/********************* lo mio *********************/

////////////////////////////////////////////////////

  void copia (const PBinTreeNode &t,PBinTreeNode &ts);
  void copyMembers(const TreeSet& from);

////////////////////////////////////////////////////

/********************* lo mio *********************/

////////////////////////////////////////////////////

};


//////////////////////////////


/* In C++ a struct is similar to a class but is used for storing related data
together. Structs are implemented almost exactly like clases, but the word 
struct replaces the word class. The only difference between a struct and a 
class in C++ is that by default data and fucntions in a struct are public, 
whereas the default in a class is that everything is private. */

struct BinTreeNode
{
  int data;
  BinTreeNode *left, *right;

  static unsigned long counter;

  BinTreeNode (int d);
  ~BinTreeNode ();
};

inline int Set::extent() const
{
  return size;
}

#endif
